<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\KategoriTps;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class KategoriTpsController extends Controller
{
    public function index()
    {
        $title = 'Kategori TPS';
        $kategori = KategoriTps::all();

        return view('admin.kategori-tps.index', compact('title', 'kategori'));
    }

    public function create()
    {
        $title = 'Tambah Kategori TPS';
        return view('admin.kategori-tps.create', compact('title'));
    }

    public function store(Request $request)
    {
        $data = $request->validate([
            'nama_kategori' => 'required|string|max:100',
            'kepanjangan_kategori' => 'nullable|string|max:255',
            'deskripsi'     => 'nullable|string',
            'foto_kategori' => 'nullable|image|mimes:jpg,jpeg,png|max:2048'
        ]);

        if ($request->hasFile('foto_kategori')) {
            $data['foto_kategori'] = $request->file('foto_kategori')
                ->store('kategori', 'public');
        }

        KategoriTps::create($data);

        return redirect()
            ->route('admin.kategori.index')
            ->with('success', 'Kategori berhasil ditambahkan');
    }

    public function edit($id)
    {
        $title = 'Edit Kategori TPS';
        $kategori = KategoriTps::findOrFail($id);

        return view('admin.kategori-tps.edit', compact('title', 'kategori'));
    }

    public function update(Request $request, $id)
    {
        $kategori = KategoriTps::findOrFail($id);

        $data = $request->validate([
            'nama_kategori' => 'required|string|max:100',
            'kepanjangan_kategori' => 'nullable|string|max:255',
            'deskripsi'     => 'nullable|string',
            'foto_kategori' => 'nullable|image|mimes:jpg,jpeg,png|max:2048'
        ]);

        if ($request->hasFile('foto_kategori')) {
            if ($kategori->foto_kategori) {
                Storage::disk('public')->delete($kategori->foto_kategori);
            }

            $data['foto_kategori'] = $request->file('foto_kategori')
                ->store('kategori', 'public');
        }

        $kategori->update($data);

        return redirect()
            ->route('admin.kategori.index')
            ->with('success', 'Kategori berhasil diperbarui');
    }

    public function destroy($id)
    {
        $kategori = KategoriTps::findOrFail($id);

        if ($kategori->foto_kategori) {
            Storage::disk('public')->delete($kategori->foto_kategori);
        }

        $kategori->delete();

        return redirect()
            ->route('admin.kategori.index')
            ->with('success', 'Kategori berhasil dihapus');
    }
}
